unit fMD_CheckIn;
{
================================================================================
*
*       Application:  Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 9/13/04 9:06a $
*       Developer:    doma.user@domain.ext
*       Site:         Hines OIFO
*
*       Description:  Patient Check-In form
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Version 1.0 - Patch 4 (Misc fixes)/CPUser/fMD_CheckIn.pas $
*
* $History: fMD_CheckIn.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/13/04   Time: 11:51a
 * Created in $/CP Version 1.0 - Patch 4 (Misc fixes)/CPUser
 *
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 7/18/03    Time: 9:05p
 * Updated in $/CP Version 1.0/CPUser
 * Team Mtg July 2003
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 12/11/02   Time: 2:16p
 * Created in $/CP Version 1.0 Patch 1/CPUser
 * Version t13 as released
 *
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ExtCtrls,
  ComCtrls,
  StdCtrls,
  TRPCB,
  uMD_Objects,
  uMD_Common,
  mMD_PatientHeader,
  ActnList,
  ImgList, System.ImageList, System.Actions;

type
  TfrmMD_CheckIn = class(TForm)
    pnlCommands: TPanel;
    btnCheckIn: TButton;
    btnCancel: TButton;
    lvConsults: TListView;
    fraMD_PatientHeader1: TfraMD_PatientHeader;
    Label1: TLabel;
    actCheckInActions: TActionList;
    actCheckIn: TAction;
    actCancelCheckIn: TAction;
    actGetVisitDateTime: TAction;
    actSelectInstrument: TAction;
    pgctrl: TPageControl;
    tbshtExistingVisits: TTabSheet;
    lvVisits: TListView;
    tbshtNewVisit: TTabSheet;
    Label2: TLabel;
    edtNewVisitDateTime: TEdit;
    btnGetDateTime: TButton;
    pnlInstruments: TPanel;
    pnlUseInstruments: TPanel;
    rbtnInstrument: TRadioButton;
    rbtnNoInstrument: TRadioButton;
    lbxInstruments: TListBox;
    Bevel2: TBevel;
    Bevel4: TBevel;
    ImageList1: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure rbtnNoInstrumentClick(Sender: TObject);
    procedure rbtnInstrumentClick(Sender: TObject);
    procedure actGetVisitDateTimeExecute(Sender: TObject);
    procedure lvConsultsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure actCheckInExecute(Sender: TObject);
    procedure actSelectInstrumentExecute(Sender: TObject);
    procedure lvVisitsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure actCancelCheckInExecute(Sender: TObject);
    procedure lvConsultsColumnClick(Sender: TObject; Column: TListColumn);
    procedure lvConsultsCompare(Sender: TObject; Item1, Item2: TListItem;
      Data: integer; var Compare: integer);
    procedure lvVisitsColumnClick(Sender: TObject; Column: TListColumn);
    procedure lvVisitsCompare(Sender: TObject; Item1, Item2: TListItem;
      Data: integer; var Compare: integer);
    procedure edtNewVisitDateTimeEnter(Sender: TObject);
    procedure edtNewVisitDateTimeChange(Sender: TObject);
    procedure edtNewVisitDateTimeExit(Sender: TObject);
  private
    FSortColumn: integer;
    FSortDescending: Boolean;
    FVSortColumn: integer;
    FVSortDescending: Boolean;
    FMDPatient: TMDPatient;
    FStudyIENS: string;
    FConsultIEN: string;
    FCPDefIEN: string;
    FInstrumentIEN: string;
    FVString: string;
    FNewVisitDate: TFMDateTime;
    FNewVisitDateChanged: Boolean;
    procedure LoadInstruments(CPDefinition: string);
    procedure LoadConsults(DFN: string);
    procedure LoadVisits(DFN: string);
    function IsItComplete: Boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMD_CheckIn: TfrmMD_CheckIn;

procedure CheckIn(Patient: TMDPatient; StudyIENS: string = '+1,');

implementation

uses fMD_GetDateTime;

{$R *.DFM}
{$WARN UNSAFE_CAST OFF}

procedure CheckIn(Patient: TMDPatient; StudyIENS: string = '+1,');
begin
  with TfrmMD_CheckIn.Create(Application) do
    begin
      FMDPatient := Patient;
      FStudyIENS := StudyIENS;
      fraMD_PatientHeader1.Patient := Patient;
      rbtnNoInstrument.Checked := True;
      lbxInstruments.Items.Clear;
      LoadConsults(FMDPatient.DFN);
      LoadVisits(FMDPatient.DFN);
      ShowModal;
    end;
end;

procedure TfrmMD_CheckIn.FormCreate(Sender: TObject);
begin
  RestoreWindow(Self);
end;

procedure TfrmMD_CheckIn.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  while lbxInstruments.Items.Count > 0 do
    begin
      TMDRecordID(lbxInstruments.Items.Objects[0]).Free;
      lbxInstruments.Items.Delete(0);
    end;
  while lvConsults.Items.Count > 0 do
    begin
      TMDConsultRequest(lvConsults.Items[0].Data).Free;
      lvConsults.Items.Delete(0);
    end;
  while lvVisits.Items.Count > 0 do
    begin
      TMDVString(lvVisits.Items[0].Data).Free;
      lvVisits.Items.Delete(0);
    end;
  SaveWindow(Self);
end;

procedure TfrmMD_CheckIn.rbtnNoInstrumentClick(Sender: TObject);
begin
  lbxInstruments.ItemIndex := -1;
  lbxInstruments.Enabled := False;
  FInstrumentIEN := '';
  IsItComplete
end;

procedure TfrmMD_CheckIn.rbtnInstrumentClick(Sender: TObject);
begin
  lbxInstruments.Enabled := True;
  IsItComplete;
end;

procedure TfrmMD_CheckIn.actGetVisitDateTimeExecute(Sender: TObject);
var
  DtWin: TDateTime;
  Hour, Min, Sec, MSec: Word;
begin
  DecodeTime(Now, Hour, Min, Sec, MSec);
  if (Min > 30) and (Hour < 23) then
    begin
      Hour := Hour + 1;
      Min := 0;
    end
  else
    Min := 30;
  DtWin := Trunc(Now) + EncodeTime(Hour, Min, 0, 0);
  if AskDateTime(DtWin, edtNewVisitDateTime) then
    begin
      FNewVisitDate := DateTimeToFMDT(DtWin, False);
      //edtNewVisitDateTime.Text := DateTimeToStr(DtWin);
      edtNewVisitDateTime.Text := FormatDateTime(FMT_FMDATETIME, FMDTToTDateTime(FNewVisitDate));
    end
  else
    edtNewVisitDateTime.SetFocus;
  IsItComplete;
end;

procedure TfrmMD_CheckIn.lvConsultsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
  with TMDConsultRequest(Item.Data) do
    if Selected then
      begin
        FConsultIEN := IEN;
        if CPDefIEN <> FCPDefIEN then
          LoadInstruments(CPDefIEN);
        FCPDefIEN := CPDefIEN;
        if CheckInCount > 0 then
          MessageDlg(
            Format(
            'Notice, this Consult/Procedure has already' + #13 +
            'been checked in with CPUser %d time(s).' + #13 + #13 +
            'Please ensure this is the correct Consult/Procedure' + #13 +
            'before continuing.', [CheckInCount]),
            mtInformation, [mbOK], 0);
      end
    else
      begin
        FConsultIEN := IEN;
        FCPDefIEN := CPDefIEN;
      end;
  IsItComplete;
end;

procedure TfrmMD_CheckIn.actCheckInExecute(Sender: TObject);
var
  SubmissionStr: string;
begin
  SubmissionStr :=
    FStudyIENS + '^' +
    FCPDefIEN + '^' +
    FConsultIEN + '^' +
    FInstrumentIEN + '^';

  // 5th '^' piece equals VString or New Visit Date/Time
  if pgctrl.ActivePage = tbshtExistingVisits then
    SubmissionStr := SubmissionStr + FVString
  else
    SubmissionStr := SubmissionStr + FloatToStr(FNewVisitDate);

  // 6th '^' piece equals 0/1 for procedure already completed
  //SubmissionStr := SubmissionStr + '^' + BOOLEAN201[cbxProcedureDone.Checked];

  CallVistaServer(MDBroker, RPC_TMDPATIENT, ['CHKIN', MDPatient.DFN, SubmissionStr], nil, SubmissionStr);
  if StrToIntDef(GetPiece(SubmissionStr, '^', 1), -1) < 0 then
    MessageDlgS(MDBroker.Results.Text, mtError);
  ModalResult := mrOK;
end;

procedure TfrmMD_CheckIn.LoadConsults(DFN: string);
var
  i: integer;
  Consult: TMDConsultRequest;
begin
  CallVistaServer(MDBroker, RPC_TMDPATIENT, ['GETCONS', DFN], nil, nil);

  //ShowMessage(MDBroker.Results.Text);

  for i := 1 to MDBroker.Results.Count - 1 do
    with lvConsults.Items.Add do
      begin
        Consult := TMDConsultRequest.CreateFromHeader(MDBroker, MDBroker.Results[i]);
        Caption := TitleCase(Consult.CPDefName);
        SubItems.Add(Consult.DateTimeOrdered);
        SubItems.Add(Consult.Urgency + '/' + Consult.Status);
        Data := Consult;
        ImageIndex := -1;
      end;
  // Here is the reverse sort order setup (Patch MD*1.0*6)
  lvConsultsColumnClick(lvConsults, lvConsults.Columns[1]);
end;

procedure TfrmMD_CheckIn.LoadVisits(DFN: string);
var
  i: integer;
  MDVString: TMDVString;
begin
  CallVistaServer(MDBroker, RPC_TMDPATIENT, ['GETVST', DFN], nil, nil);
  for i := 1 to MDBroker.Results.Count - 1 do
    begin
      MDVString := TMDVString.Create(MDBroker.Results[i]);
      if getPiece(MDBroker.Results[i], ';', 1) <> 'I' then
        with lvVisits.Items.Add do
          begin
            Data := MDVString;
            Caption := MDVString.Location;
            SubItems.Add(DateTimeToStr(MDVString.DateTime));
            SubItems.Add(MDVString.Status);
            ImageIndex := -1;
          end;
    end;

  // Here is the reverse sort order setup (Patch MD*1.0*6)
  lvVisitsColumnClick(lvVisits, lvVisits.Columns[1]);

  if lvVisits.Items.Count > 0 then
    pgctrl.ActivePage := tbshtExistingVisits
  else
    pgctrl.ActivePage := tbshtNewVisit;
end;

procedure TfrmMD_CheckIn.LoadInstruments(CPDefinition: string);
var
  i: integer;
  rec: TMDRecordID;
begin
  while lbxInstruments.Items.Count > 0 do
    begin
      TMDRecordID(lbxInstruments.Items.Objects[0]).Free;
      lbxInstruments.Items.Delete(0);
    end;

  CallVistaServer(MDBroker, RPC_TMDPROCEDURE, ['GETINST', CPDefinition], nil, nil);

  for i := 1 to MDBroker.Results.Count - 1 do
    if GetPiece(MDBroker.Results[i], '^', 3) = '1' then
      begin
        rec := TMDRecordID.CreateFromHeader(MDBroker, MDBroker.Results[i]);
        lbxInstruments.Items.AddObject(rec.HeaderData[1], rec);
      end;
  if lbxInstruments.Items.Count > 0 then
    begin
      rbtnNoInstrument.Checked := False;
      rbtnInstrument.Checked := True;
      rbtnInstrument.Enabled := True;
      lbxInstruments.Enabled := True;
      if lbxInstruments.Items.Count = 1 then
        lbxInstruments.ItemIndex := 0
      else
        lbxInstruments.ItemIndex := -1;
    end
  else
    begin
      rbtnInstrument.Checked := False;
      rbtnInstrument.Enabled := False;
      rbtnNoInstrument.Checked := True;
      lbxInstruments.Enabled := False;
    end;
  actSelectInstrumentExecute(nil);
end;

procedure TfrmMD_CheckIn.actSelectInstrumentExecute(Sender: TObject);
begin
  if lbxInstruments.ItemIndex > -1 then
    FInstrumentIEN := TMDRecordID(lbxInstruments.Items.Objects[lbxInstruments.ItemIndex]).IEN
  else
    FInstrumentIEN := '';
  IsItComplete;
end;

procedure TfrmMD_CheckIn.lvVisitsSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if Selected then
    FVString := TMDVString(Item.Data).VString
  else
    FVString := '';
  IsItComplete;
end;

function TfrmMD_CheckIn.IsItComplete: Boolean;

  function InstrumentOK: Boolean;
  begin
    if rbtnInstrument.Checked then
      Result := FInstrumentIEN <> ''
    else
      Result := FInstrumentIEN = '';
  end;

  function VisitOK: Boolean;
  begin
    if pgctrl.ActivePage = tbshtExistingVisits then
      Result := FVString <> ''
    else
      Result := (FNewVisitDate > 0);
  end;

begin
  Result := (FConsultIEN <> '') and (FCPDefIEN <> '') and InstrumentOK and VisitOK;
  btnCheckIn.Enabled := Result;
end;

procedure TfrmMD_CheckIn.actCancelCheckInExecute(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TfrmMD_CheckIn.lvConsultsColumnClick(Sender: TObject; Column: TListColumn);
begin
  lvConsults.Columns[FSortColumn].ImageIndex := -1;

  if Column.Index = FSortColumn then
    FSortDescending := (FSortDescending = False);
  FSortColumn := Column.Index;
  if FSortDescending then
    Column.ImageIndex := 0
  else
    Column.ImageIndex := 1;
  lvConsults.AlphaSort;
end;

procedure TfrmMD_CheckIn.lvConsultsCompare(Sender: TObject; Item1, Item2: TListItem; Data: integer; var Compare: integer);
begin
  case FSortColumn of
    0: Compare := AnsiCompareStr(
        Item1.Caption,
        Item2.Caption);
    1:
      begin
        if TMDConsultRequest(Item1.Data).SortableDateTimeOrdered > TMDConsultRequest(Item2.Data).SortableDateTimeOrdered then
          Compare := 1
        else
          Compare := -1;
      end
  else
    Compare := AnsiCompareStr(
      Item1.SubItems[FSortColumn - 1],
      Item2.SubItems[FSortColumn - 1]);
  end;

  if not FSortDescending then
    if Compare = 1 then
      Compare := -1
    else
      if Compare = -1 then
        Compare := 1
      else
        Compare := 0;
end;

procedure TfrmMD_CheckIn.lvVisitsColumnClick(Sender: TObject; Column: TListColumn);
begin
  lvVisits.Columns[FVSortColumn].ImageIndex := -1;

  if Column.Index = FVSortColumn then
    FVSortDescending := (FVSortDescending = False);
  FVSortColumn := Column.Index;
  if FVSortDescending then
    Column.ImageIndex := 0
  else
    Column.ImageIndex := 1;
  lvVisits.AlphaSort;
end;

procedure TfrmMD_CheckIn.lvVisitsCompare(Sender: TObject; Item1, Item2: TListItem; Data: integer; var Compare: integer);
begin
  case FVSortColumn of
    0: Compare := AnsiCompareStr(
        Item1.Caption,
        Item2.Caption);
    1:
      begin
        if TMDVString(Item1.Data).DateTime > TMDVString(Item2.Data).DateTime then
          Compare := 1
        else
          Compare := -1;
      end
  else
    Compare := AnsiCompareStr(
      Item1.SubItems[FVSortColumn - 1],
      Item2.SubItems[FVSortColumn - 1]);
  end;

  if not FVSortDescending then
    if Compare = 1 then
      Compare := -1
    else
      if Compare = -1 then
        Compare := 1
      else
        Compare := 0;
end;

procedure TfrmMD_CheckIn.edtNewVisitDateTimeEnter(Sender: TObject);
begin
  FNewVisitDateChanged := False;
end;

procedure TfrmMD_CheckIn.edtNewVisitDateTimeChange(Sender: TObject);
begin
  FNewVisitDateChanged := True;
end;

procedure TfrmMD_CheckIn.edtNewVisitDateTimeExit(Sender: TObject);
var
  x: string;
begin
  if not FNewVisitDateChanged then
    Exit;

  CallVistaServer(MDBroker, RPC_TMDRECORDID, ['DT', '', '', '', edtNewVisitDateTime.Text + '^T'], nil, x);
  if GetPiece(x, '^', 1) <> '-1' then
    begin
      FNewVisitDate := StrToFloat(GetPiece(x, '^', 2));
      edtNewVisitDateTime.Text := FormatDateTime(FMT_FMDATETIME, FMDTToTDateTime(FNewVisitDate));
    end
  else
    begin
      MessageDlgS('Invalid Date/Time: ' + edtNewVisitDateTime.Text, mtError);
      if FNewVisitDate > 0 then
        edtNewVisitDateTime.Text := FormatDateTime(FMT_FMDATETIME, FMDTToTDateTime(FNewVisitDate))
      else
        edtNewVisitDateTime.Text := '';
      edtNewVisitDateTime.SetFocus;
    end;
  IsItComplete;
end;

end.

