unit fMD_GetDateTime;
{
================================================================================
*
*       Application:  Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 8/24/04 10:49a $
*       Developer:    doma.user@domain.ext
*       Site:         Hines OIFO
*
*       Description:  Universal Date/Time retriever
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Version 1.0 - Patch 4 (Misc fixes)/CPUser/fMD_GetDateTime.pas $
*
* $History: fMD_GetDateTime.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/13/04   Time: 11:52a
 * Created in $/CP Version 1.0 - Patch 4 (Misc fixes)/CPUser
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 12/11/02   Time: 2:18p
 * Created in $/CP Version 1.0 Patch 1/CPUser
 * Version t13 as released
 *
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  ExtCtrls;

type
  TfrmMD_GetDateTime = class(TForm)
    Panel1: TPanel;
    btnOK: TButton;
    dtTime: TDateTimePicker;
    Label1: TLabel;
    dtDate: TDateTimePicker;
    Label2: TLabel;
    btnCancel: TButton;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function AskDateTime(var DateTime: TDateTime; Ctrl: TControl): Boolean;

implementation

{$R *.DFM}

function AskDateTime(var DateTime: TDateTime; Ctrl: TControl): Boolean;
var
  Pt: TPoint;
begin
  Result := False;
  with TfrmMD_GetDateTime.Create(application) do
    try
      Pt := Ctrl.Parent.ClientToScreen(Point(Ctrl.Left, Ctrl.Top));
      Left := Pt.x;
      Top := Pt.y + Ctrl.Height;
      {
      if (Screen.Width - Mouse.CursorPos.x) > Width then
        Left := Mouse.CursorPos.x
      else
        Left := Mouse.CursorPos.x - Width;

      if (Screen.Height - Mouse.CursorPos.y) > Height then
        Top := Mouse.CursorPos.y
      else
        Top := Mouse.CursorPos.y - Height;
      }
      dtDate.Date := TDate(DateTime);
      dtTime.Time := TTime(DateTime);
      ShowModal;
      if ModalResult = mrOK then
        begin
          Result := True;
          DateTime := Int(dtDate.Date) + Frac(dtTime.Time);
        end
    finally
      free;
    end;
end;

end.

