unit fMD_Main;
{
================================================================================
*
*       Application:  Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 9/13/04 9:02a $
*       Developer:    doma.user@domain.ext
*       Site:         Hines OIFO
*
*       Description:  Main form of CPUser.exe
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Version 1.0 - Patch 4 (Misc fixes)/CPUser/fMD_Main.pas $
*
* $History: fMD_Main.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/13/04   Time: 11:57a
 * Created in $/CP Version 1.0 - Patch 4 (Misc fixes)/CPUser
 *
 * *****************  Version 5  *****************
 * User: Zzzzzzpetitd Date: 10/06/03   Time: 11:06a
 * Updated in $/CP Version 1.0/CPUser
 * Final check-in for SQA version t22
 *
 * *****************  Version 4  *****************
 * User: Zzzzzzpetitd Date: 2/28/03    Time: 3:58p
 * Updated in $/CP Version 1.0 Patch 1/CPUser
 * Pre 1.0t18 release
 *
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 12/20/02   Time: 2:24p
 * Updated in $/CP Version 1.0 Patch 1/CPUser
 * Release t15 finalized
 * Enhancements include:
 * 1. User information added to CPUser main form
 * 2. Consult type corrected on report display
 * 3. Min/Max window issues corrected in Results window
 * 4. Single character lookup issue resolved
 * 5. IP Port updated to allow 1000-99999
 * 6. Pt Confirmation changed to Titlecase for space concerns
 * 7. Changing dates on clinic lookup fixed
 *
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 12/13/02   Time: 8:27a
 * Updated in $/CP Version 1.0 Patch 1/CPUser
 * Removed reference to CPBitMap.res.
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 12/11/02   Time: 2:24p
 * Created in $/CP Version 1.0 Patch 1/CPUser
 * Version t13 as released
 *
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Forms,
  Dialogs,
//  mMD_PatientHeader,
  uMD_Objects,
  ImgList,
  ExtCtrls,
  ToolWin,
  ComCtrls,
  StdCtrls,
  Controls,
  Classes,
  Menus,
  ActnList, System.ImageList, System.Actions, mMD_PatientHeader,  Vcl.HtmlHelpViewer;

type
  TfrmMain = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    OpenPatient1: TMenuItem;
    NewStudy1: TMenuItem;
    Help1: TMenuItem;
    sb: TStatusBar;
    pnlMain: TPanel;
    Label1: TLabel;
    lvStudies: TListView;
    actMain: TActionList;
    actFileOpenPatient: TAction;
    actFileNewStudy: TAction;
    actFileOpenStudy: TAction;
    mnFileOpenStudy: TMenuItem;
    Splitter1: TSplitter;
    actExitApplication: TAction;
    N1: TMenuItem;
    mnFileExit: TMenuItem;
    lbxTreatingSpecialties: TListBox;
    actSwitchTreatingSpecialties: TAction;
    ilMainSmall: TImageList;
    actUpdateStatus: TAction;
    mnFileUpdateStatus: TMenuItem;
    actFileDeleteStudy: TAction;
    mnFileDelete: TMenuItem;
    mnHelpContents: TMenuItem;
    mnHelpWeb: TMenuItem;
    N2: TMenuItem;
    mnHelpAbout: TMenuItem;
    actHelpContents: TAction;
    actHelpWeb: TAction;
    actHelpAbout: TAction;
    actFileRefresh: TAction;
    mnFileRefresh: TMenuItem;
    Bevel1: TBevel;
    tbar: TToolBar;
    tbtnOpenPatient: TToolButton;
    tbtnRefreshPatient: TToolButton;
    tbtnCheckInNewStudy: TToolButton;
    tbtnOpenStudy: TToolButton;
    tbtnDeleteStudy: TToolButton;
    ToolButton1: TToolButton;
    tbtnHelp: TToolButton;
    tbtnWeb: TToolButton;
    mnView: TMenuItem;
    mnToolsToolBar: TMenuItem;
    actToolBarOnOff: TAction;
    actSubmitToImaging: TAction;
    fraMD_PatientHeader1: TfraMD_PatientHeader;
    tmrDefaultHandler: TTimer;
    procedure actFileOpenPatientExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure actExitApplicationExecute(Sender: TObject);
    procedure actFileNewStudyExecute(Sender: TObject);
    procedure actSwitchTreatingSpecialtiesExecute(Sender: TObject);
    procedure lvStudiesSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure actFileOpenStudyExecute(Sender: TObject);
    procedure lvStudiesColumnClick(Sender: TObject; Column: TListColumn);
    procedure lvStudiesCompare(Sender: TObject; Item1, Item2: TListItem; Data: integer; var Compare: integer);
    procedure actUpdateStatusExecute(Sender: TObject);
    procedure actHelpWebExecute(Sender: TObject);
    procedure actHelpAboutExecute(Sender: TObject);
    procedure actHelpContentsExecute(Sender: TObject);
    procedure actFileDeleteStudyExecute(Sender: TObject);
    procedure actFileRefreshExecute(Sender: TObject);
    procedure actToolBarOnOffExecute(Sender: TObject);
    procedure tmrDefaultHandlerTimer(Sender: TObject);
    procedure sbResize(Sender: TObject);
  private
    FSortColumn: integer;
    FSortDescending: Boolean;
    FCurrentPtIEN: string;
    FDefaultHandlerAct: string;
    FDefaultHandlerDFN: string;
    procedure SetCurrentPtIEN(const Value: string);
  public
    FVistaMsg: Word;
    procedure DefaultHandler(var Message); override;
    property CurrentPtIEN: string
      read FCurrentPtIEN write SetCurrentPtIEN;
  end;

var
  frmMain: TfrmMain;

implementation

uses
  fMD_Study,
  fMD_CheckIn,
  uMD_Common,
  fMD_LookupPatient,
  fMD_SelectPatient,
  fMD_UpdateStatus,
  fMD_QuickCheckIn,
  fMD_AboutDlg,
  tMD_CPRSMessage;

{$R *.DFM}
{$WARN UNSAFE_CAST OFF}

procedure TfrmMain.FormCreate(Sender: TObject);
var
  i: integer;
begin
  RestoreWindow(Self);
  sb.Panels[0].Text := 'User: ' + MDUser.Name + '  (' + MDUser.Title + ')';
  sb.Panels[1].Text := 'Division: ' + MDUser.Division;
  tmrDefaultHandler.Enabled := False;
  FSortColumn := 0;
  FSortDescending := True;
  lvStudies.Columns[0].ImageIndex := 0;
  fraMD_PatientHeader1.Patient := MDPatient;
  FVistaMsg := RegisterWindowMessage('VistA Event - Clinical');
  {Load active treating specialties}
  CallVistaServer(MDBroker, RPC_TMDPROCEDURE, ['GETSPEC', 'ACTIVE'], nil, nil);
  for i := 1 to MDBroker.Results.Count - 1 do
    begin
      lbxTreatingSpecialties.Items.AddObject(
        TitleCase(GetPiece(MDBroker.Results[i], '^', 2)),
        TMDRecordID.CreateFromHeader(MDBroker, MDBroker.Results[i]));
    end;
  if MDRunAsCPRSSlave then
    begin
      actFileOpenPatient.Caption := 'Use CPRS to Select Patient';
      actFileOpenPatient.Enabled := False;
    end;
  if MDInitialDFN <> '' then
    CurrentPtIEN := MDInitialDFN;
  mnToolsToolBar.Checked := (MDUser.GetUserParameter(usToolBars) = '1');
  tbar.Visible := mnToolsToolBar.Checked;

  SetHelpIDs(Self, HELPUSER_MAIN);
end;

procedure TfrmMain.DefaultHandler(var Message);
// adds check to the message handling for this form to get a registered message
// this is where CPRS sends us new patient IEN
var
  buf: array[0..255] of Char;
begin
  // do the default message handling
  inherited DefaultHandler(Message);
  // if the message is 'VistA Event - Clinical' and not posted from self...
  // wParam=Handle of message sender, lParam=entry in global atom table
  if MDRunAsCPRSSlave then
    with TMessage(Message) do
      if (Msg = FVistaMsg) and (wParam <> Handle) then
        begin
          // retrieve the text pointed to by lParam into a buffer
          GlobalGetAtomName(lParam, buf, 255);
          if GetPiece(StrPas(Buf), '^', 2) = 'CPRS' then
            begin
              (**)
              // This method sets up the timer to fire and do it.
              // Set values for the timer to use and set the time to fire;
              // Currently the only workable solution
              FDefaultHandlerAct := GetPiece(StrPas(Buf), '^', 1);
              FDefaultHandlerDFN := GetPiece(StrPas(Buf), '^', 3);
              tmrDefaultHandler.Enabled := True;
              (**)

              (*
              // This is the original way from CPRS documentation
              // It died with the new Shared Broker
              if GetPiece(StrPas(Buf), '^', 1) = 'XPT' then
                // Set the CurrentPtIEN property of this form to the new IEN from CPRS
                // this allows for a single pt swithing mechanism regardless of run mode.
                CurrentPtIEN := GetPiece(StrPas(Buf), '^', 3);
              if GetPiece(StrPas(Buf), '^', 1) = 'END' then
                // Set the CurrentPtIEN property of this form to blank and close.
                begin
                  CurrentPtIEN := '';
                  Close;
                end;
              *)
            end;
        end;
end;

procedure TfrmMain.tmrDefaultHandlerTimer(Sender: TObject);
begin
  tmrDefaultHandler.Enabled := False;
  if FDefaultHandlerAct = 'XPT' then
    CurrentPtIEN := FDefaultHandlerDFN
  else
    if FDefaultHandlerAct = 'END' then
      Close;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveWindow(Self);
end;

procedure TfrmMain.actFileOpenPatientExecute(Sender: TObject);
var
  sIEN: string;
begin
  MDPatient.DFN := '';
  lvStudies.Items.Clear;
  if (LookupPatient(MDBroker, sIEN)) and (SelectPatient(MDBroker, sIEN)) then
    begin
      MDPatient.DFN := sIEN;
      pnlMain.Visible := True;
      actSwitchTreatingSpecialtiesExecute(Sender);
    end
  else
    begin
      MDPatient.DFN := '';
      pnlMain.Visible := False;
    end;
  fraMD_PatientHeader1.Patient := MDPatient;
  actFileNewStudy.Enabled := (MDPatient.DFN <> '');
  actFileRefresh.Enabled := (MDPatient.DFN <> '');
end;

procedure TfrmMain.actExitApplicationExecute(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.actFileNewStudyExecute(Sender: TObject);
begin
  CheckIn(MDPatient);
  MDPatient.LoadStudies;
  actSwitchTreatingSpecialties.Execute;
end;

procedure TfrmMain.actSwitchTreatingSpecialtiesExecute(Sender: TObject);
var
  i: integer;
begin
  with lvStudies.Items do
    begin
      BeginUpdate;
      Clear;
      if lbxTreatingSpecialties.ItemIndex > -1 then
        with TMDRecordID(lbxTreatingSpecialties.Items.Objects[lbxTreatingSpecialties.ItemIndex]) do
          for i := 0 to MDPatient.StudyCount - 1 do
            if MDPatient.Studies[i].TreatingSpecialityIEN = IEN then
              with Add do
                begin
                  ImageIndex := 3;
                  Caption := TitleCase(MDPatient.Studies[i].ProcedureName);
                  SubItems.Add(MDPatient.Studies[i].DateCreated);
                  SubItems.Add(MDPatient.Studies[i].Status);
                  SubItems.Add(MDPatient.Studies[i].Instrument);
                  SubItems.Add(IntToStr(MDPatient.Studies[i].ImageCount));
                  Data := MDPatient.Studies[i];
                end;
      EndUpdate;
    end;
  lvStudies.AlphaSort;
end;

procedure TfrmMain.lvStudiesSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
  actFileOpenStudy.Enabled := Selected;
  actUpdateStatus.Enabled := Selected and MDUSer.CPManager;
  actFileDeleteStudy.Enabled := Selected and MDUser.CPManager;
end;

procedure TfrmMain.actFileOpenStudyExecute(Sender: TObject);
var
  Study: TMDStudy;
  ExternalStatus: string;
  InternalStatus: TMDStudyStatus;
begin
  if lvStudies.Selected <> nil then
    begin
      Study := TMDStudy(lvStudies.Selected.Data);
      ExternalStatus := Study.FieldValue('.09');
      InternalStatus := TMDStudyStatus(StrToIntDef(Study.FieldValue('.09', True), 0));

      if lvStudies.Selected.SubItems[1] <> ExternalStatus then
        begin
          Study.UpdateStatus(InternalStatus);
          lvStudies.Selected.SubItems[1] := ExternalStatus;
          if MessageDlgS('The status of this study has changed since it was' + #13 +
            'first accessed, the new status is ' + ExternalStatus + #13 +
            'Do you want to continue with this operation?', mtConfirmation, [mbYes, mbNo, mbCancel]) <> mrYes then
            Exit;
        end;

      case StrToIntDef(Study.FieldValue('.09', True), -1) of
        -1:
          begin
            MessageDlgS('Cannot continue, Study has no status', mtError);
          end;
        0:
          begin
            QuickCheckIn(Study);
          end;
        1:
          begin
            MessageDlgS(
              'This study is currently waiting on a response' + #13 +
              'from the VistA Imaging Server and cannot be accessed' + #13 +
              'from this screen.  Please contact your Clinical Procedures' + #13 +
              'coordinator or ADPAC for assistance if study needs to be' + #13 +
              'corrected.');
          end;
        2:
          begin
            if MDUser.CPManager then
              actUpdateStatus.Execute
            else
              MessageDlgS(
                'This study is currently in an error state and needs to be' + #13 +
                'corrected before continuing.  Please contact your Clinical Procedures' + #13 +
                'coordinator or ADPAC for assistance.');
          end;
        3:
          begin
            ShowStudy(MDBroker, Study, True);
          end;
        4:
          begin
            ShowStudy(MDBroker, Study);
          end;
        5:
          begin
            if MessageDlgS(
              'This study is marked as Pending Instrument Data' + #13 +
              'Are you sure you want to open it?', mtConfirmation, [mbYes, mbNo, mbCancel]) = mrYes then
              ShowStudy(MDBroker, Study);
          end;
      end;
      {Update the image count and the listview}
      Study.ImageCount := StrToIntDef(Study.FieldValue('.991'), 0);
      lvStudies.Selected.SubItems[3] := IntToStr(Study.ImageCount);
      lvStudies.Selected.SubItems[1] := Study.Status;
    end;
end;

procedure TfrmMain.lvStudiesColumnClick(Sender: TObject; Column: TListColumn);
begin
  lvStudies.Columns[FSortColumn].ImageIndex := -1;

  if Column.Index = FSortColumn then
    FSortDescending := (FSortDescending = False);
  FSortColumn := Column.Index;
  if FSortDescending then
    Column.ImageIndex := 0
  else
    Column.ImageIndex := 1;
  lvStudies.AlphaSort;
end;

procedure TfrmMain.lvStudiesCompare(Sender: TObject; Item1, Item2: TListItem; Data: integer; var Compare: integer);
begin
  case FSortColumn of
    0: Compare := AnsiCompareStr(
        Item1.Caption,
        Item2.Caption);
    1:
      begin
        if TMDStudy(Item1.Data).SortableDateCreated > TMDStudy(Item2.Data).SortableDateCreated then
          Compare := 1
        else
          Compare := -1;
      end
  else
    Compare := AnsiCompareStr(
      Item1.SubItems[FSortColumn - 1],
      Item2.SubItems[FSortColumn - 1]);
  end;

  if not FSortDescending then
    if Compare = 1 then
      Compare := -1
    else
      if Compare = -1 then
        Compare := 1
      else
        Compare := 0;
end;

procedure TfrmMain.actUpdateStatusExecute(Sender: TObject);
var
  Study: TMDStudy;
begin
  Study := TMDStudy(lvStudies.Selected.Data);
  UpdateStatus(MDBroker, Study);
  lvStudies.Selected.SubItems[1] := Study.FieldValue('.09');
end;

procedure TfrmMain.actHelpWebExecute(Sender: TObject);
begin
  DisplayCPHomePage;
end;

procedure TfrmMain.actHelpAboutExecute(Sender: TObject);
begin
  MDAboutDlg.Execute;
end;

procedure TfrmMain.actHelpContentsExecute(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, HELPUSER_MAIN);
end;

procedure TfrmMain.SetCurrentPtIEN(const Value: string);
begin
  FCurrentPtIEN := Value;
  MDPatient.DFN := FCurrentPtIEN;
  fraMD_PatientHeader1.Patient := MDPatient;
  actFileNewStudy.Enabled := (FCurrentPtIEN <> '');
  actFileRefresh.Enabled := (FCurrentPtIEN <> '');
  pnlMain.Visible := (FCurrentPtIEN <> '');
  Application.ProcessMessages;
  actSwitchTreatingSpecialties.Execute;
end;

procedure TfrmMain.actFileDeleteStudyExecute(Sender: TObject);
var
  Study: TMDStudy;
  RetStatus: string;
begin
  if MessageDlgS(
    'Are you sure you want to delete this study?',
    mtConfirmation,
    [mbYes, mbNo, mbCancel]) = mrYes then
    begin
      Study := TMDStudy(lvStudies.Selected.Data);
      CallVistaServer(MDBroker, RPC_TMDTRANSACTION, ['DELETE', Study.IEN], nil, RetStatus);
      if GetPiece(RetStatus, '^', 1) = '-1' then
        MessageDlgS('Unable to delete this study: ' + #13 + 'Reason: ' + GetPiece(RetStatus, '^', 2))
      else
        begin
          MDPatient.LoadStudies;
          actSwitchTreatingSpecialties.Execute;
        end
    end;
end;

procedure TfrmMain.actFileRefreshExecute(Sender: TObject);
begin
  if MDPatient <> nil then
    begin
      MDPatient.LoadStudies;
      actSwitchTreatingSpecialties.Execute;
    end;
end;

procedure TfrmMain.actToolBarOnOffExecute(Sender: TObject);
var
  NewVal: Boolean;
begin
  NewVal := (not mnToolsToolBar.Checked);
  mnToolsToolBar.Checked := NewVal;
  tbar.Visible := NewVal;
  MDUser.SetUserParameter(usToolBars, BOOLEAN201[NewVal]);
end;

procedure TfrmMain.sbResize(Sender: TObject);
begin
  sb.Panels[0].Width := Trunc(sb.Width * 0.45);
  sb.Panels[1].Width := Trunc(sb.Width * 0.45);
end;

end.

