unit fMD_Study;
{
================================================================================
*
*       Application:  Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 8/24/04 10:50a $
*       Developer:    doma.user@domain.ext
*       Site:         Hines OIFO
*
*       Description:  Study Update form
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Version 1.0 - Patch 4 (Misc fixes)/CPUser/fMD_Study.pas $
*
* $History: fMD_Study.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/13/04   Time: 12:01p
 * Created in $/CP Version 1.0 - Patch 4 (Misc fixes)/CPUser
 * 
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 12/20/02   Time: 2:25p
 * Updated in $/CP Version 1.0 Patch 1/CPUser
 * Release t15 finalized
 * Enhancements include:
 * 1. User information added to CPUser main form
 * 2. Consult type corrected on report display
 * 3. Min/Max window issues corrected in Results window
 * 4. Single character lookup issue resolved
 * 5. IP Port updated to allow 1000-99999
 * 6. Pt Confirmation changed to Titlecase for space concerns
 * 7. Changing dates on clinic lookup fixed
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 12/11/02   Time: 2:30p
 * Created in $/CP Version 1.0 Patch 1/CPUser
 * Version t13 as released
 *
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  TRPCB,
  Dialogs,
  ComCtrls,
  ToolWin,
  StdCtrls,
  Buttons,
  ExtCtrls,
  FileCtrl,
  mMD_PatientHeader,
  uMD_Objects,
  fMD_GetResults,
  Menus,
  ImgList,
  ActnList, System.ImageList, System.Actions;

type
  TfrmMD_Study = class(TForm)
    pnlDisplay: TPanel;
    sBar: TStatusBar;
    fraMD_PatientHeader1: TfraMD_PatientHeader;
    pnlTIUNote: TPanel;
    Bevel3: TBevel;
    Label7: TLabel;
    lblTIUNote: TLabel;
    pnlInstrument: TPanel;
    Bevel4: TBevel;
    Label6: TLabel;
    lblInstrument: TLabel;
    pnlStatus: TPanel;
    Bevel5: TBevel;
    Label8: TLabel;
    lblStatus: TLabel;
    pnlConsult: TPanel;
    lblConsult: TLabel;
    Bevel2: TBevel;
    Label5: TLabel;
    actStudy: TActionList;
    actViewConsult: TAction;
    ilStudyForm: TImageList;
    actViewTIUNote: TAction;
    actAddInstrumentData: TAction;
    actRemoveAttachment: TAction;
    actAddExternalAttachment: TAction;
    sbtnViewTIUNote: TSpeedButton;
    sbtnViewConsult: TSpeedButton;
    MainMenu1: TMainMenu;
    mnFile: TMenuItem;
    mnView: TMenuItem;
    mnViewTIUNote: TMenuItem;
    mnViewConsult: TMenuItem;
    mnAttachments: TMenuItem;
    mnAttachmentsAddInstrumentData: TMenuItem;
    mnAttachmentsAddExternal: TMenuItem;
    mnAttachmentRemoveExternal: TMenuItem;
    actViewAllergies: TAction;
    ViewAllergies1: TMenuItem;
    actSubmitToImaging: TAction;
    mnFileSubmitToImaging: TMenuItem;
    actLoadAttachments: TAction;
    actApplyChanges: TAction;
    pnlCPDef: TPanel;
    Bevel1: TBevel;
    Label1: TLabel;
    lblCPDef: TLabel;
    pnlBottom: TPanel;
    Bevel6: TBevel;
    btnCancel: TButton;
    btnApply: TButton;
    btnOK: TButton;
    BitBtn1: TBitBtn;
    pnlAttachments: TPanel;
    Label11: TLabel;
    pnlAttachmentsAddSubtract: TPanel;
    bbtnAddFiles: TBitBtn;
    bbtnAddResults: TBitBtn;
    bbtnRemoveFiles: TBitBtn;
    lvAttachments: TListView;
    actOK: TAction;
    procedure actAddExternalAttachmentExecute(Sender: TObject);
    procedure lvExternalAttachmentsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure actRemoveAttachmentExecute(Sender: TObject);
    procedure actAddInstrumentDataExecute(Sender: TObject);
    procedure actLoadAttachmentsExecute(Sender: TObject);
    procedure actViewConsultExecute(Sender: TObject);
    procedure actViewTIUNoteExecute(Sender: TObject);
    procedure lvAttachmentsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure actApplyChangesExecute(Sender: TObject);
    procedure actSubmitToImagingExecute(Sender: TObject);
    procedure actOKExecute(Sender: TObject);
    procedure actViewAllergiesExecute(Sender: TObject);
  private
    FStudy: TMDStudy;
    FFilesToAdd: TStringList;
    FFilesToRemove: TStringList;
    { Private declarations }
  public
    procedure ShowStatus(AStatus: string = '');
    { Public declarations }
  end;

procedure ShowStudy(ABroker: TRPCBroker; AStudy: TMDStudy; AReadOnly: Boolean = False);

implementation

uses uMD_Common,
  fMD_TextDisplayPrint;

{$R *.DFM}

procedure ShowStudy(ABroker: TRPCBroker; AStudy: TMDStudy; AReadOnly: Boolean = False);
begin
  with TfrmMD_Study.Create(Application) do
    try
      FStudy := AStudy;
      FFilesToAdd := TStringList.Create;
      FFilesToRemove := TStringList.Create;
      fraMD_PatientHeader1.Patient := MDPatient;
      lblCPDef.Caption := FStudy.ProcedureName;
      lblStatus.Caption := AStudy.Status;
      lblInstrument.Caption := AStudy.Instrument;
      lblTIUNote.Caption := AStudy.FieldValue('.06');
      actViewTIUNote.Enabled := (lblTIUNote.Caption <> '');
      if lblTIUNote.Caption <> '' then
        lblTIUNote.Caption := 'TIU Note Title: ' + lblTIUNote.Caption
      else
        lblTIUNote.Caption := 'No TIU Note Entered';
      lblConsult.Caption := AStudy.FieldValue('.05');
      actViewConsult.Enabled := (lblConsult.Caption <> '');
      if lblConsult.Caption <> '' then
        lblConsult.Caption := 'No. ' + lblConsult.Caption
      else
        lblConsult.Caption := 'No consult entered';
      if lblConsult.Caption = '' then
        lblConsult.Caption := 'No Consult Procedure Order Found';
      actLoadAttachments.Execute;
      bbtnAddFiles.Visible := (GetParameterValue(xparAllowExternalAttachments, peSystem) = 'YES');
      actSubmitToImaging.Enabled :=
        (FStudy.FieldValue('.09', True) = '4') and
        (not AReadOnly);
      if AReadOnly then
        begin
          Caption := Caption + ' [Read Only]';
          pnlAttachments.Enabled := False;
          actAddInstrumentData.Enabled := False;
          actAddExternalAttachment.Enabled := False;
          actRemoveAttachment.Enabled := False;
          btnApply.Enabled := False;
        end;
      ShowModal;
    finally
      FreeAndNil(FFilesToAdd);
      FreeAndNil(FFilesToRemove);
      Free;
    end;
end;

procedure TfrmMD_Study.actAddExternalAttachmentExecute(Sender: TObject);
var
  i: integer;
  UNCName: string;
begin
  with TOpenDialog.Create(Self) do
    try
      InitialDir := FStudy.FieldValue('.04:.08');
      if InitialDir = '' then
        InitialDir := ExtractFileDir(Application.Exename);
      if not SysUtils.DirectoryExists(InitialDir) then
        begin
          MessageDlgS(
            'The default directory for this procedure ''' + InitialDir + ''' does not exist.' + #13 +
            'Defaulting to directory ''' + ExtractFileDir(Application.Exename) + '''');
          InitialDir := ExtractFileDir(Application.Exename);
        end;
      Title := 'Select External Study Attachments';
      Filter := CPFilesFilter;
      Options := [ofHideReadOnly, ofAllowMultiSelect, ofPathMustExist, ofFileMustExist, ofShareAware, ofEnableSizing];
      if Execute then
        begin
          lvAttachments.Items.BeginUpdate;
          for i := 0 to Files.Count - 1 do
            begin
              UNCName := LowerCase(ExpandUNCFileName(Files[i]));
              if lvAttachments.FindCaption(0, UNCName, False, True, True) = nil then
                begin
                  if FFilesToAdd.IndexOf(UNCName) < 0 then
                    FFilesToAdd.Add(UNCName);
                  with lvAttachments.Items.Add do
                    Caption := UNCName;
                  actApplyChanges.Enabled := True;
                end;
            end;
          lvAttachments.Items.EndUpdate;
        end;
    finally
      free;
    end;
end;

procedure TfrmMD_Study.lvExternalAttachmentsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
  actRemoveAttachment.Enabled := ((Item <> nil) and Selected);
end;

procedure TfrmMD_Study.actRemoveAttachmentExecute(Sender: TObject);
var
  i: integer;
begin
  with lvAttachments do
    begin
      Items.BeginUpdate;
      for i := Items.Count - 1 downto 0 do
        if Items[i].Selected then
          begin
            if FFilesToRemove.IndexOf(Lowercase(Items[i].Caption)) < 0 then
              FFilesToRemove.Add(Lowercase(Items[i].Caption));
            Items.Delete(i);
            actApplyChanges.Enabled := True;
          end;
      Items.EndUpdate;
    end;
end;

procedure TfrmMD_Study.actAddInstrumentDataExecute(Sender: TObject);
var
  i: integer;
  InstrumentFiles: TStringList;
begin
  InstrumentFiles := TStringList.Create;
  try
    if GetInstrumentResults(FStudy, InstrumentFiles) then
      begin
        for i := 0 to InstrumentFiles.Count - 1 do
          if (FFilesToAdd.IndexOf(InstrumentFiles[i]) < 0) and
            (lvAttachments.FindCaption(0, InstrumentFiles[i], False, True, True) = nil) then
            begin
              FFilesToAdd.Add(InstrumentFiles[i]);
              with lvAttachments.Items.Add do
                Caption := InstrumentFiles[i];
              actApplyChanges.Enabled := True;
            end;
      end;
  finally
    FreeAndNil(InstrumentFiles);
  end;
end;

procedure TfrmMD_Study.actLoadAttachmentsExecute(Sender: TObject);
var
  Ret: TStringList;
  i: integer;
begin
  Ret := TStringList.Create;
  try
    CallVistaServer(MDBroker, RPC_TMDTRANSACTION, ['GETATT', FStudy.IEN], nil, Ret);
    for i := 1 to Ret.Count - 1 do
      with lvAttachments.Items.Add do
        Caption := GetPiece(Ret[i], '^', 4);
  finally
    FreeAndNil(Ret);
  end;
end;

procedure TfrmMD_Study.ShowStatus(AStatus: string);
begin
  if AStatus <> '' then
    sBar.SimpleText := 'Status ' + AStatus
  else
    sBar.SimpleText := '';
  sBar.Refresh;
  Application.ProcessMessages;
end;

procedure TfrmMD_Study.actViewConsultExecute(Sender: TObject);
var
  ConsultText: TStringList;
begin
  ConsultText := TStringList.Create;
  try
    CallVistaServer(MDBroker, RPC_TMDPATIENT, ['DISPCON', MDPatient.DFN, FStudy.FieldValue('.05')], nil, ConsultText);
    ConsultText.Delete(0);
    DisplayText('Consult Display', ConsultText);
  finally
    FreeAndNil(ConsultText);
  end;
end;

procedure TfrmMD_Study.actViewTIUNoteExecute(Sender: TObject);
var
  TIUText: TStringList;
begin
  TIUText := TStringList.Create;
  try
    CallVistaServer(MDBroker, RPC_TMDTRANSACTION, ['VIEWTIU', FStudy.IEN], nil, TIUText);
    DisplayText('TIU Note Display', TIUText);
  finally
    FreeAndNil(TIUText);
  end;
end;

procedure TfrmMD_Study.lvAttachmentsSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  actRemoveAttachment.Enabled := (lvAttachments.SelCount > 0);
end;

procedure TfrmMD_Study.actApplyChangesExecute(Sender: TObject);
var
  i: integer;
begin
  while FFilesToRemove.Count > 0 do
    begin
      i := FFilesToAdd.IndexOf(FFilesToRemove[0]);
      if i > -1 then
        begin
          {
          This file was in both lists
          Remove from both and do nothing else
          ShowMessage(FFilesToAdd[i]+' is on both list, no change needed');
          }
          FFilesToAdd.Delete(i);
          FFilesToRemove.Delete(0);
        end
      else
        begin
          ShowStatus('Removing File ' + FFilesToRemove[0]);
          FStudy.RemoveFile(FFilesToRemove[0]);
          FFilesToRemove.Delete(0);
        end;
    end;
  while FFilesToAdd.Count > 0 do
    begin
      ShowStatus('Adding File ' + FFilesToAdd[0]);
      FStudy.AddFile(FFilesToAdd[0]);
      FFilesToAdd.Delete(0);
    end;
  actApplyChanges.Enabled := False;
  ShowStatus;
end;

procedure TfrmMD_Study.actSubmitToImagingExecute(Sender: TObject);
var
  Msg: string;
begin
  actApplyChanges.Execute;
  ShowStatus('Submitting to VistA Imaging...');
  if FStudy.SubmitToVistaImaging(Msg) then
    ModalResult := mrOk
  else
    MessageDlgS('Error submitting study.' + #13 + 'Message: ' + Msg, mtError);
  ShowStatus;
end;

procedure TfrmMD_Study.actOKExecute(Sender: TObject);
begin
  if actApplyChanges.Enabled then
    actApplyChanges.Execute;
  ModalResult := mrOk;
end;

procedure TfrmMD_Study.actViewAllergiesExecute(Sender: TObject);
begin
  fraMD_PatientHeader1.ShowAllergies;
end;

end.

