unit fMD_UpdateStatus;
{
================================================================================
*
*       Application:  Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 8/24/04 10:50a $
*       Developer:    doma.user@domain.ext
*       Site:         Hines OIFO
*
*       Description:  Update study status form
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Version 1.0 - Patch 4 (Misc fixes)/CPUser/fMD_UpdateStatus.pas $
*
* $History: fMD_UpdateStatus.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/13/04   Time: 12:02p
 * Created in $/CP Version 1.0 - Patch 4 (Misc fixes)/CPUser
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 12/11/02   Time: 2:32p
 * Created in $/CP Version 1.0 Patch 1/CPUser
 * Version t13 as released
 *
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  TRPCB,
  uMD_Common,
  uMD_Objects,
  ExtCtrls;

type
  TfrmMD_UpdateStatus = class(TForm)
    btnCancel: TButton;
    btnOK: TButton;
    Label1: TLabel;
    lblStatus: TLabel;
    Label2: TLabel;
    lblErrorMessage: TLabel;
    Memo1: TMemo;
    rgNewStatus: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure rgNewStatusClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FCurrentStatus: integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMD_UpdateStatus: TfrmMD_UpdateStatus;

procedure UpdateStatus(ABroker: TRPCBroker; AStudy: TMDStudy);

implementation

{$R *.DFM}

procedure UpdateStatus(ABroker: TRPCBroker; AStudy: TMDStudy);
begin
  with TfrmMD_UpdateStatus.Create(Application) do
    try
      FCurrentStatus := StrToIntDef(AStudy.FieldValue('.09', True), -1);
      lblStatus.Caption := AStudy.FieldValue('.09');
      lblErrorMessage.Caption := AStudy.FieldValue('.08');
      AStudy.DisplayErrors(Memo1);
      if ShowModal = mrOk then
        AStudy.UpdateStatus(TMDStudyStatus(rgNewStatus.ItemIndex));
    finally
      Free;
    end;
end;

procedure TfrmMD_UpdateStatus.FormCreate(Sender: TObject);
var
  i: TMDstudyStatus;
begin
  RestoreWindow(Self);
  for i := Low(TMDStudyStatus) to High(TMDStudyStatus) do
    rgNewStatus.Items.Add(MDSTUDYSTATUS[i]);
end;

procedure TfrmMD_UpdateStatus.rgNewStatusClick(Sender: TObject);
begin
  btnOK.Enabled := rgNewStatus.ItemIndex <> FCurrentStatus;
end;

procedure TfrmMD_UpdateStatus.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SaveWindow(Self);
end;

end.

