unit mMD_PatientHeader;
{
================================================================================
*
*       Application:  Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 8/24/04 10:50a $
*       Developer:    doma.user@domain.ext
*       Site:         Hines OIFO
*
*       Description:  Universal Patient Header Frame
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Version 1.0 - Patch 4 (Misc fixes)/CPUser/mMD_PatientHeader.pas $
*
* $History: mMD_PatientHeader.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/13/04   Time: 12:03p
 * Created in $/CP Version 1.0 - Patch 4 (Misc fixes)/CPUser
 * 
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 12/20/02   Time: 2:25p
 * Updated in $/CP Version 1.0 Patch 1/CPUser
 * Release t15 finalized
 * Enhancements include:
 * 1. User information added to CPUser main form
 * 2. Consult type corrected on report display
 * 3. Min/Max window issues corrected in Results window
 * 4. Single character lookup issue resolved
 * 5. IP Port updated to allow 1000-99999
 * 6. Pt Confirmation changed to Titlecase for space concerns
 * 7. Changing dates on clinic lookup fixed
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 12/11/02   Time: 2:33p
 * Created in $/CP Version 1.0 Patch 1/CPUser
 * Version t13 as released
 *
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  TRPCB,
  ExtCtrls,
  StdCtrls,
  Buttons,
  uMD_Common,
  uMD_Objects;

type
  TfraMD_PatientHeader = class(TFrame)
    Panel2: TPanel;
    pnlAllergies: TPanel;
    pnlPtDemographics: TPanel;
    lblPatientInformation: TLabel;
    Panel3: TPanel;
    Label1: TLabel;
    Image1: TImage;
    procedure pnlMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; x, Y: integer);
  private
    FPatient: TMDPAtient;
    procedure SetPatient(const Value: TMDPAtient);
    { Private declarations }
  public
    procedure ShowAllergies;
    property Patient: TMDPAtient
      read FPatient write SetPatient;
  end;

implementation

uses fMD_TextDisplayPrint;

{$R *.DFM}

{ TfraMD_PatientHeader }

procedure TfraMD_PatientHeader.SetPatient(const Value: TMDPAtient);
begin
  FPatient := Value;
  lblPatientInformation.Caption := Value.Demographics;
  pnlPtDemographics.Color := COLOR_PTBACKGROUND;
  lblPatientInformation.Font.Color := COLOR_PTFOREGROUND;
end;

procedure TfraMD_PatientHeader.ShowAllergies;
var
  sList: TStringList;
begin
  if MDPatient <> nil then
    if MDPatient.DFN <> '' then
      begin
        pnlAllergies.BevelOuter := bvLowered;
        pnlAllergies.Refresh;
        sList := TStringList.Create;
        try
          CallVistaServer(MDBroker, RPC_TMDPATIENT, ['ALLERGY', MDPatient.DFN], nil, sList);
          //DisplayText('Allergies', sList);
          DisplayText('Allergies',sList,False,False);
        finally
          FreeAndNil(sList);
          pnlAllergies.BevelOuter := bvRaised;
          pnlAllergies.Refresh;
        end;
      end;
end;

procedure TfraMD_PatientHeader.pnlMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; x, Y: integer);
begin
  ShowAllergies;
end;

end.

