unit tMD_CPRSMessage;
{
================================================================================
*
*       Application:  Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 8/24/04 10:50a $
*       Developer:    doma.user@domain.ext
*       Site:         Hines OIFO
*
*       Description:  Switch Patient Thread
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Version 1.0 - Patch 4 (Misc fixes)/CPUser/tMD_CPRSMessage.pas $
*
* $History: tMD_CPRSMessage.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/13/04   Time: 12:04p
 * Created in $/CP Version 1.0 - Patch 4 (Misc fixes)/CPUser
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 12/11/02   Time: 2:34p
 * Created in $/CP Version 1.0 Patch 1/CPUser
 * Version t13 as released
 *
 *
*
================================================================================
}

interface

uses
  ActiveX,
  Classes,
  uMD_Common;

type
  TCPRSMessage = class(TThread)
  private
    FCPRSMessage: string;
  protected
    procedure Execute; override;
    procedure Switch;
  public
    constructor Create(CPRSMsg: string);
  end;

implementation

uses
  fMD_Main;
{ Important: Methods and properties of objects in VCL can only be used in a
  method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TCPRSMessage.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ TCPRSMessage }

constructor TCPRSMessage.Create(CPRSMsg: string);
begin
  inherited Create(False);
  FCPRSMessage := CPRSMsg;
  Priority := tpNormal;
  FreeOnTerminate := True;
end;

procedure TCPRSMessage.Execute;
begin
  //Synchronize(Switch);
  Switch;
  MessageDlgS('we just switched to ' + FCPRSMessage);
end;

procedure TCPRSMessage.Switch;
begin
  if GetPiece(FCPRSMessage, '^', 1) = 'XPT' then
    // Set the CurrentPtIEN property of this form to the new IEN from CPRS
    // this allows for a single pt swithing mechanism regardless of run mode.
    frmMain.CurrentPtIEN := GetPiece(FCPRSMessage, '^', 3);
  if GetPiece(FCPRSMessage, '^', 1) = 'END' then
    // Set the CurrentPtIEN property of this form to blank and close.
    begin
      frmMain.CurrentPtIEN := '';
      frmMain.Close;
    end;
end;

end.

