unit fMD_AboutDlg;
{
================================================================================
*
*       Application:  Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 8/24/04 11:05a $
*       Developer:    doma.user@domain.ext
*       Site:         Hines OIFO
*
*       Description:  About Dialog
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Version 1.0 - Patch 4 (Misc fixes)/Common/fMD_AboutDlg.pas $
*
* $History: fMD_AboutDlg.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/13/04   Time: 11:13a
 * Created in $/CP Version 1.0 - Patch 4 (Misc fixes)/Common
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 12/10/02   Time: 2:28p
 * Created in $/CP Version 1.0 Patch 1/Common
 * Version t13 as released
 *
 *
*
================================================================================
}
interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  Filectrl;

type
  TfrmMD_AboutDlg = class(TForm)
    Panel1: TPanel;
    lblProductNameInset: TLabel;
    lblClientVersion: TLabel;
    lblCopyright: TLabel;
    lblReleaseDate: TLabel;
    Label2: TLabel;
    lblReleaseDateLabel: TLabel;
    Label4: TLabel;
    lblPatchLabel: TLabel;
    lblPatch: TLabel;
    lblProductNameShadow: TLabel;
    Panel2: TPanel;
    ApplicationImage: TImage;
    OKButton: TButton;
    Label1: TLabel;
    lblHelpFile: TLabel;
    Panel3: TPanel;
    pnlComments: TPanel;
    lblComments: TLabel;
    lblSecurity: TLabel;
    Label3: TLabel;
    lblServerVersion: TLabel;
    lblCompileDate: TLabel;
    lblCRCValue: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    lblTestRelease: TLabel;
    procedure FormCreate(Sender: TObject);
  public
    procedure Execute;
  end;

var
  MDAboutDlg: TfrmMD_AboutDlg;

implementation

{$R *.DFM}

uses
  uMD_Common;

procedure TfrmMD_AboutDlg.Execute;
begin
  with TfrmMD_AboutDlg.Create(self) do
    try
      showmodal;
    finally
      free;
    end;
end;

procedure TfrmMD_AboutDlg.FormCreate(Sender: TObject);
begin
  lblProductNameInset.Font.Color := clActiveCaption;
  lblProductNameShadow.Font.Color := clBtnHighlight;

  lblProductNameShadow.Top := lblProductNameInset.Top + 1;
  lblProductNameShadow.Left := lblProductNameInset.Left + 1;

  lblHelpFile.Caption := MinimizeName(Application.HelpFile, lblHelpFile.Canvas, lblHelpFile.Width);
  lblHelpFile.Hint := 'Help file name: ' + Application.HelpFile;
  lblHelpFile.ShowHint := (Pos('...', lblHelpFile.Caption) > 0);

  with MDVersionInformation do
    begin
      lblCRCValue.Caption := CRCValue;
      lblProductNameInset.Caption := ProductName;
      lblProductNameShadow.Caption := ProductName;
      Self.Caption := 'About ' + ProductName;
      lblClientVersion.Caption := FileVersion;
      lblServerVersion.Caption := VAVersionNumber;
      lblPatch.Caption := VAPatchNumber;
      lblPatchLabel.Visible := (VAPatchNumber <> '');
      lblCompileDate.Caption := CompiledDateTime;
      lblReleaseDate.Caption := VAReleaseDate;
      lblCopyright.Caption := LegalCopyRight;
      lblComments.Width := pnlComments.Width;
      lblComments.Height := pnlComments.Height;
      lblComments.Caption := Comments;
      if Debugbuild then
        lblTestRelease.Caption := 'DEBUG VERSION';
      if PreRelease or DebugBuild then
        lblTestRelease.Visible := True;
    end;
end;

end.

