{
================================================================================
*
*       Application:  Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 8/24/04 11:05a $
*       Developer:    doma.user@domain.ext
*       Site:         Hines OIFO
*
*       Description:  Generic splash form for all CP .exe's
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Version 1.0 - Patch 4 (Misc fixes)/Common/fMD_Splash.pas $
*
* $History: fMD_Splash.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/13/04   Time: 11:15a
 * Created in $/CP Version 1.0 - Patch 4 (Misc fixes)/Common
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 12/10/02   Time: 2:31p
 * Created in $/CP Version 1.0 Patch 1/Common
 * Version t13 as released
 *
 *
*
*
================================================================================
}
unit fMD_Splash;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls;

type
  TfrmMD_Splash = class(TForm)
    Panel1: TPanel;
    lblShadow: TLabel;
    lblInset: TLabel;
    Panel2: TPanel;
    lblVersion: TLabel;
    lblDevelopedAt: TLabel;
    lblReleaseDate: TLabel;
    lblMessage: TLabel;
    pnlPatch: TPanel;
    lblpatch: TLabel;
    Panel3: TPanel;
    Image1: TImage;
    lblTestRelease: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure ShowSplashScreen;
procedure HideSplashScreen;
procedure FreeSplashScreen;

var
  frmMD_Splash: TfrmMD_Splash;

implementation

uses uMD_Common;

{$R *.DFM}

procedure ShowSplashScreen;
begin
  if frmMD_Splash = nil then
    frmMD_Splash := TfrmMD_Splash.Create(Application);
  frmMD_Splash.Show;
end;

procedure HideSplashScreen;
begin
  if frmMD_Splash <> nil then
    frmMD_Splash.Hide;
end;

procedure FreeSplashScreen;
begin
  FreeAndNil(frmMD_Splash);
end;

procedure TfrmMD_Splash.FormCreate(Sender: TObject);
begin
  panel1.Ctl3D := False;
  lblVersion.Caption := 'Version: ' + MDVersionInformation.VAVersionNumber;
  lblPatch.Caption := 'Patch: ' + MDVersionInformation.VAPatchNumber;
  pnlPatch.Visible := (MDVersionInformation.VAPatchNumber <> '');
  lblReleaseDate.Caption := MDVersionInformation.VAReleaseDate;
  lblInset.Caption := MDVersionInformation.ProductName;
  lblShadow.Caption := MDVersionInformation.ProductName;
  lblInset.Font.Color := clActiveCaption;
  lblShadow.Font.Color := clbtnHighlight;
  lblShadow.Left := lblInset.Left + 1;
  lblShadow.Top := lblInset.Top + 1;
  if MDVersionInformation.DebugBuild then
    lblTestRelease.Caption := 'DEBUG BUILD';
  lblTestRelease.Visible := (MDVersionInformation.PreRelease or MDVersionInformation.DebugBuild);
  Show;
  Application.ProcessMessages;
end;

end.

