unit fMD_TextDisplayPrint;
{
================================================================================
*
*       Application:  Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 8/24/04 11:05a $
*       Developer:    doma.user@domain.ext
*       Site:         Hines OIFO
*
*       Description:  Generic text/report display form
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Version 1.0 - Patch 4 (Misc fixes)/Common/fMD_TextDisplayPrint.pas $
*
* $History: fMD_TextDisplayPrint.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/13/04   Time: 11:16a
 * Created in $/CP Version 1.0 - Patch 4 (Misc fixes)/Common
 * 
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 12/20/02   Time: 2:20p
 * Updated in $/CP Version 1.0 Patch 1/Common
 * Release t15 finalized
 * Enhancements include:
 * 1. User information added to CPUser main form
 * 2. Consult type corrected on report display
 * 3. Min/Max window issues corrected in Results window
 * 4. Single character lookup issue resolved
 * 5. IP Port updated to allow 1000-99999
 * 6. Pt Confirmation changed to Titlecase for space concerns
 * 7. Changing dates on clinic lookup fixed
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 12/10/02   Time: 2:32p
 * Created in $/CP Version 1.0 Patch 1/Common
 * Version t13 as released
 *
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Buttons,
  ExtCtrls,
  ComCtrls;

type
  TfrmMD_TextDisplayPrint = class(TForm)
    Panel1: TPanel;
    bbtnPrint: TBitBtn;
    bbtnPrintSetup: TBitBtn;
    bbtnClose: TBitBtn;
    redtText: TRichEdit;
    procedure bbtnPrintClick(Sender: TObject);
    procedure bbtnPrintSetupClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure DisplayText(ACaption: string; AText: TStringList; AAllowPrinting: Boolean = False; ReportView: Boolean = True);

implementation

uses uMD_Common;

{$R *.DFM}

procedure DisplayText(ACaption: string; AText: TStringList; AAllowPrinting: Boolean = False; ReportView: Boolean = True);
begin
  with TfrmMD_TextDisplayPrint.Create(Application) do
    try
      Caption := ACaption;
      bbtnPrint.Visible := AAllowPrinting;
      bbtnPrintSetup.Visible := AAllowPrinting;
      redtText.Lines.Assign(AText);
      if ReportView then
        begin
          Width := trunc(Screen.Width * 0.7);
          Height := trunc(Screen.Height * 0.8);
          BorderStyle := bsSizeable;
        end
      else
        begin
          Width := trunc(Screen.Width * 0.4);
          Height := trunc(Screen.Height * 0.4);
          BorderStyle := bsDialog;
        end;
      Position := poScreenCenter;
      ShowModal;
    finally
      Free;
    end;
end;

procedure TfrmMD_TextDisplayPrint.bbtnPrintClick(Sender: TObject);
begin
  redtText.Print(Caption);
end;

procedure TfrmMD_TextDisplayPrint.bbtnPrintSetupClick(Sender: TObject);
begin
  with TPrinterSetupDialog.Create(Application) do
    try
      Execute;
    finally
      free;
    end;
end;

end.

